CodeForces 321A Ciel and Robot(数学模拟)

题目链接:http://codeforces.com/problemset/problem/321/A

题意:在一个二维平面中,開始时在(0,0)点,目标点是(a。b),问能不能通过反复操作题目中的指令,从原点移动到目标点。

分析:如果一次完毕全部的命令后。移动到了(xx,yy),而且从(Xi。Yi)反复操作k次指令到达目标点。则能够列出方程 Xi + k * xx = a && Yi + k * yy = b。然后解出k。推断k是否大于等于0就可以。

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
typedef __int64 LL;
LL a, b, xx, yy;
LL X[150], Y[150];
int len;
bool check(LL x, LL y) {
    LL tmp_x = a - x, tmp_y = b - y;
    if(xx == 0) {
        if(yy == 0) {
            if(tmp_x == 0 && tmp_y == 0) return true;
            else return false;
        }
        else {
            if(tmp_y % yy == 0) {
                if(tmp_y / yy >= 0 && tmp_x == 0) return true;
                else return false;
            }
            else return false;
        }
    }
    else {
        if(yy == 0) {
            if(tmp_x % xx == 0) {
                if(tmp_x / xx >= 0 && tmp_y == 0) return true;
                else return false;
            }
            else return false;
        }
        else {
            if(tmp_x % xx == 0 && tmp_y % yy == 0) {
                if(tmp_x / xx >= 0 && tmp_y / yy >= 0 && tmp_x / xx == tmp_y / yy) return true;
                else return false;
            }
            else return false;
        }
    }
}

int main() {
    char op[150];
    while(~scanf("%I64d%I64d", &a, &b)) {
        scanf("%s", op);
        if(a == 0 && b == 0) {
            printf("Yes\n");
            continue;
        }
        len = strlen(op);
        LL x = 0, y = 0;
        int FLAG = 0;
        for(int i = 0; i < len; i++) {
            if(op[i] == ‘U‘) y++;
            else if(op[i] == ‘D‘) y--;
            else if(op[i] == ‘L‘) x--;
            else if(op[i] == ‘R‘) x++;
            X[i] = x, Y[i] = y;
        }
        xx = X[len-1], yy = Y[len-1];
        for(int i = 0; i < len; i++) {
            if(check(X[i], Y[i])) {
                FLAG = 1;
                printf("Yes\n");
                break;
            }
        }
        if(!FLAG)  printf("No\n");
    }
    return 0;
}
时间: 2024-11-04 12:30:34

CodeForces 321A Ciel and Robot(数学模拟)的相关文章

Codeforces 321A Ciel and Robot 枚举答案

题目链接 枚举机器人走的最后一步,用终点坐差后计算周期次数 trick:周期次数要>=0 #include <iostream> #include <string> #include <vector> #include <cstring> #include <cstdio> #include <map> #include <queue> #include <algorithm> #include <

Codeforces G. Ciel the Commander

题目描述: Ciel the Commander time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output Now Fox Ciel becomes a commander of Tree Land. Tree Land, like its name said, has n cities connected by n?-?1 undire

CodeForces 321 A - Ciel and Robot

[题目链接]:click here~~ [题目大意]:一个robot 机器人 ,可以根据给定的指令行动,给你四种指令,robot初始位置是(0,0),指令一出,robot会重复行动,判断能否在无限行动的情况下经过点(n,m). [解题思路]其实仔细模拟一下,可以发现是有周期的,判断即可,见代码吧~~ 代码: #include <iostream> #include <algorithm> #include <bits/stdc++.h> using namespace

CodeForces 321C Ciel the Commander

Ciel the Commander Time Limit: 1000ms Memory Limit: 262144KB This problem will be judged on CodeForces. Original ID: 321C64-bit integer IO format: %I64d      Java class name: (Any) Now Fox Ciel becomes a commander of Tree Land. Tree Land, like its na

Codeforces 321E Ciel and Gondolas

传送门:http://codeforces.com/problemset/problem/321/E [题解] 首先有一个$O(n^2k)$的dp. # include <stdio.h> # include <string.h> # include <iostream> # include <algorithm> // # include <bits/stdc++.h> using namespace std; typedef long lon

Codeforces 321B Ciel and Duel KM

题目链接 题意: 类似于游戏王的卡牌游戏,每个随从都有嘲讽... 输入n m 下面n行给出对手的随从当前状态和强壮值. 下面m行给出自己的随从的强壮值. 表示自己有m个随从,对手有n个随从.每个随从有一个强壮值. 现在是自己进攻的回合,自己的每个随从可以攻击一次(也可以不攻击) 若对手的随从都死光了,那么可以直接攻击玩家,造成与强壮值相等的伤害. 否则就要先攻击对手的随从. 对手的随从有防御状态(Defense) 和 攻击状态(Attack),每个随从也有一个强壮值. 1.若攻击对手的攻击状态随

Codeforces 321C Ciel the Commander 树分治裸题

题目链接 题意: 给定一棵树,要用字母A-Z 填到每个节点上 字母可以无限使用,但A至多只能用一次 目标:对于任意两个相同字母的节点,他们之间的路径上必须有至少一个节点的字母比他们小 例如:在两个C之间至少要有一个A 或者一个B 问: 输出填涂方案. 树分治即可,最多支持2^25个节点,不会无解. #include <iostream> #include <string> #include <vector> #include <cstring> #inclu

codeforces 321E Ciel and Gondolas 四边形不等式

题目大意:给定n个人,需要分k次过河,两个人i,j如果同乘一条船就会产生ai,j的代价,求最终代价的最小值 这个玩应显然满足四边形不等式(虽然我并不知道这个不等式是啥 然后就是决策单调(虽然我并不知道为何满足四边形不等式一定决策单调 然后就能分治做辣... 定义Solve(l,r,optl,optr)表示当前在处理区间[l,r],最优决策区间为[optl,optr] 然后我们用区间[optl,min(optr,mid?1)]的f值来更新f[mid],并记录最优决策点pos 那么[l,mid?1]

CodeForces 354A - Vasya and Robot (简单思维)

题意: 有一个机器人   他有两只手,一只左手一只右手,他面前摆了一排东西,左手只能从最左边拿,右手只能从最右边拿,每个东西有一个重量w[i]  ,   左手拿起这样东西需要消耗 w[i] * l  的能量, 右手拿起这样东西需要消耗w[i] * r 的能量,如果连续使用左手或者右手还需要多消耗 Q1或者Q2的能量,问拿走所有东西所需要消耗的最少能量是多少? 题解: 最后的状态无非就是左边一节为左手拿的,右边一节为右手拿的, 我们只需要枚举分界点,然后看左边右边差了多少个物品就可以知道多少次过载